<template>
  <div class="card">
    <div class="card-header">
      <h3 class="card-title">
        <DatabaseIcon class="text-gray" />
        New dataset
      </h3>
      <div class="card-options">
        <b-input-group>
          <template #prepend>
            <div class="input-group-text">
              <span
                v-b-tooltip.click.bottom="{ variant: 'light' }"
                title="Dataset name must be alphanumeric characters, hyphens and underscores."
                class="form-help"
                html="true"
                >?</span
              >
            </div>
          </template>
          <b-form-input
            id="input-dataset-name"
            v-model="$v.title.$model"
            data-cy="input-dataset-name"
            data-hint="Type here a name for your dataset"
            data-hintposition="top-middle"
            name="input-dataset-name"
            type="text"
            class="form-control input-identifier"
            :class="$v.title.$invalid && $v.title.$dirty ? 'is-invalid' : ''"
            placeholder="Dataset name"
            autocomplete="off"
            @keyup.enter="!loading ? createDataset() : null"
          >
          </b-form-input>
          <template #append>
            <button
              id="btn-send-files"
              data-cy="btn-send-files"
              data-hint="Click here to upload your dataset files"
              data-hintposition="top-middle"
              class="btn btn-indigo btn-sm"
              :class="availableToUpload ? '' : 'disabled'"
              :disabled="!availableToUpload"
              type="button"
              @click="createDataset()"
            >
              <span v-if="!loading">Start upload</span>
              <b-spinner v-else label="Loading..."></b-spinner>
            </button>
          </template>
        </b-input-group>
      </div>
    </div>
    <div class="card-body p-0">
      <Dropzone
        id="dropzone"
        ref="myDropzone"
        class="upload upload-bordered h-100"
        :options="dropzoneOptions"
        :use-custom-slot="true"
        @vdropzone-file-added="onFileAdded"
        @vdropzone-error="onError"
        @vdropzone-success="onSuccess"
        @vdropzone-complete="onComplete"
        @vdropzone-removed-file="onRemoved"
      >
        <div class="upload-icon dz-clickable">
          <img
            class="h-8 mt-2 mb-2"
            src="/illustrations/upload-datasets.svg"
            height="128"
          />
        </div>
        <p class="upload-subtitle text-muted dx-clickable">
          Drop files here or click to upload
        </p>
      </Dropzone>
    </div>
  </div>
</template>

<script>
import Dropzone from 'nuxt-dropzone';
import 'nuxt-dropzone/dropzone.css';
import { required, helpers } from 'vuelidate/lib/validators';
import regexParser from 'regex-parser';
import notificationsMixin from '~/mixins/notifications.js';

export default {
  components: {
    Dropzone,
  },
  mixins: [notificationsMixin],
  data() {
    return {
      loading: false,
      dropzoneOptions: {
        url: 'https://riba.risis.io',
        thumbnailWidth: 150,
        autoProcessQueue: false,
        addRemoveLinks: true,
        dictDefaultMessage: 'Drop files here or click to upload',
      },
      files: [],
      title: '',
    };
  },
  computed: {
    availableToUpload() {
      return !this.$v.title.$invalid && this.files.length > 0 && !this.loading;
    },
  },
  validations() {
    return {
      title: {
        required,
        regex: helpers.regex(
          'regex',
          new RegExp(regexParser('/^[a-zA-Z0-9][a-zA-Z0-9_-]*$/'))
        ),
      },
    };
  },
  methods: {
    onFileAdded(e) {
      this.files.push(e);
      if (!this.title) {
        if (e.name.includes('.')) {
          this.title = e.name.split('.').slice(0, -1).join('.');
        } else {
          this.title = e.name;
        }
      }
    },
    onError() {},
    onSuccess() {},
    onComplete() {},
    onRemoved(e) {
      const index = this.files
        .map((file) => file.upload.uuid)
        .indexOf(e.upload.uuid);
      if (index >= 0) {
        this.files.splice(index, 1);
      }
      if (this.files.length === 0) {
        this.title = '';
      }
    },
    async createDataset() {
      if (this.availableToUpload) {
        this.loading = true;
        const data = {
          title: this.$v.title.$model,
        };
        if (this.files.length > 0) {
          data.files = this.files;
        }
        const result = await this.$nuxt.context.store
          .dispatch('datasets/createDataset', data)
          .catch(() => {
            this.showErrorNotification('Error creating dataset');
            return null;
          })
          .finally(() => {
            this.$store.commit('ui/setDatasetCreateVisible', false);
            this.loading = false;
          });
        if (result) {
          this.$nuxt.context.store.commit('ui/setDatasetCreateVisible', false);
          if (this.$nuxt.$route.path === '/datasets') {
            await this.$nuxt.context.store.dispatch('datasets/fetchDatasets');
          } else {
            this.$router.push({
              path: `/datasets`,
            });
          }
        }
      }
    },
  },
};
</script>
